Index: /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf_crs.F90
===================================================================
--- /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf_crs.F90	(revision 5105)
+++ /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf_crs.F90	(revision 5105)
@@ -0,0 +1,182 @@
+MODULE trczdf_crs
+   !!==============================================================================
+   !!                 ***  MODULE  trczdf  ***
+   !! Ocean Passive tracers : vertical diffusive trends 
+   !!=====================================================================
+   !! History :  9.0  ! 2005-11 (G. Madec)  Original code
+   !!       NEMO 3.0  ! 2008-01  (C. Ethe, G. Madec)  merge TRC-TRA 
+   !!----------------------------------------------------------------------
+#if defined key_top
+   !!----------------------------------------------------------------------
+   !!   'key_top'                                                TOP models
+   !!----------------------------------------------------------------------
+   !!   trc_ldf     : update the tracer trend with the lateral diffusion
+   !!       ldf_ctl : initialization, namelist read, and parameters control
+   !!----------------------------------------------------------------------
+   USE oce_trc         ! ocean dynamics and active tracers
+   USE trc             ! ocean passive tracers variables
+   USE trcnam_trp      ! passive tracers transport namelist variables
+   USE trazdf_exp      ! vertical diffusion: explicit (tra_zdf_exp     routine)
+   USE trazdf_imp_crs      ! vertical diffusion: implicit (tra_zdf_imp     routine)
+   USE trdmod_oce
+   USE trdtra
+   USE prtctl_trc      ! Print control
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   trc_zdf_crs          ! called by step.F90 
+   PUBLIC   trc_zdf_alloc_crs    ! called by nemogcm.F90 
+
+   INTEGER ::   nzdf = 0               ! type vertical diffusion algorithm used
+      !                                ! defined from ln_zdf...  namlist logicals)
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:) ::  r2dt   ! vertical profile time-step, = 2 rdttra
+      !                                                 ! except at nittrc000 (=rdttra) if neuler=0
+
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+#  include "zdfddm_substitute.h90"
+#  include "vectopt_loop_substitute.h90"
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id: trczdf.F90 3294 2012-01-28 16:44:18Z rblod $ 
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+   
+   INTEGER FUNCTION trc_zdf_alloc_crs()
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE trc_zdf_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( r2dt(jpk) , STAT=trc_zdf_alloc_crs )
+      !
+      IF( trc_zdf_alloc_crs /= 0 )   CALL ctl_warn('trc_zdf_alloc_crs : failed to allocate array.')
+      !
+   END FUNCTION trc_zdf_alloc_crs
+
+
+   SUBROUTINE trc_zdf_crs( kt )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE trc_zdf  ***
+      !!
+      !! ** Purpose :   compute the vertical ocean tracer physics.
+      !!---------------------------------------------------------------------
+      INTEGER, INTENT( in ) ::  kt      ! ocean time-step index
+      !
+      INTEGER               ::  jk, jn
+      CHARACTER (len=22)    :: charout
+      REAL(wp), POINTER, DIMENSION(:,:,:,:) ::   ztrtrd   ! 4D workspace
+      !!---------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 )  CALL timing_start('trc_zdf')
+      !
+      IF( kt == nittrc000 )   CALL zdf_ctl          ! initialisation & control of options
+
+#if ! defined key_pisces
+      IF( neuler == 0 .AND. kt == nittrc000 ) THEN     ! at nittrc000
+         r2dt(:) =  rdttrc(:)           ! = rdttrc (restarting with Euler time stepping)
+      ELSEIF( kt <= nittrc000 + 1 ) THEN          ! at nittrc000 or nittrc000+1
+         r2dt(:) = 2. * rdttrc(:)       ! = 2 rdttrc (leapfrog)
+      ENDIF
+#else
+      r2dt(:) =  rdttrc(:)              ! = rdttrc (for PISCES use Euler time stepping)
+#endif
+
+      IF( l_trdtrc )  THEN
+         CALL wrk_alloc( jpi, jpj, jpk, jptra, ztrtrd )
+         ztrtrd(:,:,:,:)  = tra(:,:,:,:)
+      ENDIF
+!      WRITE(numout,*) 'nzdf', nzdf
+      SELECT CASE ( nzdf )                       ! compute lateral mixing trend and add it to the general trend
+      CASE ( -1 )                                       ! esopa: test all possibility with control print
+         CALL tra_zdf_exp( kt, nittrc000, 'TRC', r2dt, nn_trczdf_exp, trb, tra, jptra ) 
+         WRITE(charout, FMT="('zdf1 ')") ;  CALL prt_ctl_trc_info(charout)
+                                            CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
+         CALL tra_zdf_imp_crs( kt, nittrc000, 'TRC', r2dt,                trb, tra, jptra ) 
+         WRITE(charout, FMT="('zdf2 ')") ;  CALL prt_ctl_trc_info(charout)
+                                            CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
+      CASE ( 0 ) ;  CALL tra_zdf_exp( kt, nittrc000, 'TRC', r2dt, nn_trczdf_exp, trb, tra, jptra )    !   explicit scheme 
+      CASE ( 1 ) ;  CALL tra_zdf_imp_crs( kt, nittrc000, 'TRC', r2dt,                trb, tra, jptra )    !   implicit scheme          
+
+      END SELECT
+
+      IF( l_trdtra )   THEN                      ! save the vertical diffusive trends for further diagnostics
+         DO jn = 1, jptra
+            DO jk = 1, jpkm1
+               ztrtrd(:,:,jk,jn) = ( ( tra(:,:,jk,jn) - trb(:,:,jk,jn) ) / r2dt(jk) ) - ztrtrd(:,:,jk,jn)
+            END DO
+            CALL trd_tra( kt, 'TRC', jn, jptra_trd_zdf, ztrtrd(:,:,:,jn) )
+         END DO
+         CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztrtrd )
+      ENDIF
+      !                                          ! print mean trends (used for debugging)
+      IF( ln_ctl )   THEN
+         WRITE(charout, FMT="('zdf ')") ;  CALL prt_ctl_trc_info(charout)
+                                           CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
+      END IF
+      !
+      IF( nn_timing == 1 )  CALL timing_stop('trc_zdf')
+      !
+   END SUBROUTINE trc_zdf_crs
+
+
+   SUBROUTINE zdf_ctl
+      !!----------------------------------------------------------------------
+      !!                 ***  ROUTINE zdf_ctl  ***
+      !!
+      !! ** Purpose :   Choose the vertical mixing scheme
+      !!
+      !! ** Method  :   Set nzdf from ln_zdfexp
+      !!      nzdf = 0   explicit (time-splitting) scheme (ln_trczdf_exp=T)
+      !!           = 1   implicit (euler backward) scheme (ln_trczdf_exp=F)
+      !!      NB: The implicit scheme is required when using : 
+      !!             - rotated lateral mixing operator
+      !!             - TKE, GLS or KPP vertical mixing scheme
+      !!----------------------------------------------------------------------
+
+      !  Define the vertical tracer physics scheme
+      ! ==========================================
+
+      ! Choice from ln_zdfexp already read in namelist in zdfini module
+      IF( ln_trczdf_exp ) THEN           ! use explicit scheme
+         nzdf = 0
+      ELSE                               ! use implicit scheme
+         nzdf = 1
+      ENDIF
+
+      ! Force implicit schemes
+      IF( ln_trcldf_iso                               )   nzdf = 1      ! iso-neutral lateral physics
+      IF( ln_trcldf_hor .AND. ln_sco                  )   nzdf = 1      ! horizontal lateral physics in s-coordinate
+#if defined key_zdftke || defined key_zdfgls || defined key_zdfkpp
+                                                          nzdf = 1      ! TKE, GLS or KPP physics       
+#endif
+      IF( ln_trczdf_exp .AND. nzdf == 1 )   THEN
+         CALL ctl_stop( 'trc_zdf : If using the rotated lateral mixing operator or TKE, GLS or KPP vertical scheme ', &
+            &           '          the implicit scheme is required, set ln_trczdf_exp = .false.' )
+      ENDIF
+
+      ! Test: esopa
+      IF( lk_esopa )    nzdf = -1                      ! All schemes used
+
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'trc:zdf_ctl : vertical passive tracer physics scheme'
+         WRITE(numout,*) '~~~~~~~~~~~'
+         IF( nzdf == -1 )   WRITE(numout,*) '              ESOPA test All scheme used'
+         IF( nzdf ==  0 )   WRITE(numout,*) '              Explicit time-splitting scheme'
+         IF( nzdf ==  1 )   WRITE(numout,*) '              Implicit (euler backward) scheme'
+      ENDIF
+
+   END SUBROUTINE zdf_ctl
+#else
+   !!----------------------------------------------------------------------
+   !!   Default option                                         Empty module
+   !!----------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE trc_zdf_crs( kt )
+      INTEGER, INTENT(in) :: kt  
+      WRITE(*,*) 'trc_zdf: You should not have seen this print! error?', kt
+   END SUBROUTINE trc_zdf_crs
+#endif
+   !!==============================================================================
+END MODULE trczdf_crs
Index: /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 5104)
+++ /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 5105)
@@ -8,4 +8,181 @@
    !!----------------------------------------------------------------------
 #if defined key_top
+
+#if defined key_crs
+
+  !* Domain size *
+   USE par_oce , ONLY :   jpi      =>   jpi        !: first  dimension of grid --> i 
+   USE par_oce , ONLY :   jpj      =>   jpj        !: second dimension of grid --> j  
+   USE par_oce , ONLY :   jpk      =>   jpk        !: number of levels  
+   USE par_oce , ONLY :   jpim1    =>   jpim1      !: jpi - 1
+   USE par_oce , ONLY :   jpjm1    =>   jpjm1      !: jpj - 1 
+   USE par_oce , ONLY :   jpkm1    =>   jpkm1      !: jpk - 1  
+   USE par_oce , ONLY :   jpij     =>   jpij       !: jpi x jpj
+   USE par_oce , ONLY :   lk_esopa =>   lk_esopa   !: flag to activate the all option
+   USE par_oce , ONLY :   jp_tem   =>   jp_tem     !: indice for temperature
+   USE par_oce , ONLY :   jp_sal   =>   jp_sal     !: indice for salinity
+
+   !* IO manager *
+   USE in_out_manager
+
+   !* Memory Allocation *
+   USE wrk_nemo
+
+   !* Timing *
+   USE timing, ONLY : timing_start , timing_stop
+
+   !* MPP library                         
+   USE lib_mpp
+
+   !* Fortran utilities                         
+   USE lib_fortran
+
+   !* Lateral boundary conditions                         
+   USE lbclnk
+
+   !* physical constants *
+   USE phycst
+
+   !* 1D configuration
+   USE c1d
+
+   !* model domain *
+   USE dom_oce , ONLY : narea => narea
+   USE dom_oce , ONLY : nproc => nproc
+   USE dom_oce , ONLY : nimpp => nimpp
+   USE dom_oce , ONLY : njmpp => njmpp
+   USE dom_oce , ONLY : nreci => nreci
+   USE dom_oce , ONLY : nrecj => nrecj
+   USE dom_oce , ONLY : nlci  => nlci
+   USE dom_oce , ONLY : nldi  => nldi
+   USE dom_oce , ONLY : nlei  => nlei
+   USE dom_oce , ONLY : nlcj  => nlcj
+   USE dom_oce , ONLY : nldj  => nldj
+   USE dom_oce , ONLY : nlej  => nlej
+   USE dom_oce , ONLY : nlcit  => nlcit
+   USE dom_oce , ONLY : nldit  => nldit
+   USE dom_oce , ONLY : nleit  => nleit
+   USE dom_oce , ONLY : nlcjt  => nlcjt
+   USE dom_oce , ONLY : nldjt  => nldjt
+   USE dom_oce , ONLY : nlejt  => nlejt
+   USE dom_oce , ONLY : nimppt => nimppt
+   USE dom_oce , ONLY : njmppt => njmppt
+   USE dom_oce , ONLY : ibonit => ibonit
+   USE dom_oce , ONLY : ibonjt => ibonjt
+   USE dom_oce , ONLY : lk_vvl => lk_vvl
+   USE dom_oce , ONLY : rdt => rdt
+   USE dom_oce , ONLY : ln_zco => ln_zco
+   USE dom_oce , ONLY : ln_zps => ln_zps
+   USE dom_oce , ONLY : ln_sco => ln_sco
+   USE dom_oce , ONLY : neuler => neuler
+
+   USE crs,  ONLY : mi0 => mi0 
+   USE crs,  ONLY : mi1 => mi1 
+   USE crs,  ONLY : mj0 => mj0 
+   USE crs,  ONLY : mj1 => mj1 
+
+   USE dom_oce , ONLY :  lzoom => lzoom 
+   !USE dom_oce , ONLY :  => 
+
+   !* horizontal mesh *
+   USE crs , ONLY :   glamt      =>   glamt_crs      !: longitude of t-point (degre)  
+   USE crs , ONLY :   glamu      =>   glamu_crs      !: longitude of t-point (degre)  
+   USE crs , ONLY :   glamv      =>   glamv_crs      !: longitude of t-point (degre)  
+   USE crs , ONLY :   glamf      =>   glamf_crs      !: longitude of t-point (degre)  
+   USE crs , ONLY :   gphit      =>   gphit_crs      !: latitude  of t-point (degre)   
+   USE crs , ONLY :   gphiu      =>   gphiu_crs      !: latitude  of t-point (degre)   
+   USE crs , ONLY :   gphiv      =>   gphiv_crs      !: latitude  of t-point (degre)   
+   USE crs , ONLY :   gphif      =>   gphif_crs      !: latitude  of t-point (degre)   
+   USE crs , ONLY :   e1t        =>   e1t_crs        !: horizontal scale factors at t-point (m)  
+   USE crs , ONLY :   e2t        =>   e2t_crs        !: horizontal scale factors at t-point (m)   
+   USE crs , ONLY :   e1e2t      =>   e1e2t_crs      !: cell surface at t-point (m2)
+   USE crs , ONLY :   e1u        =>   e1u_crs        !: horizontal scale factors at u-point (m)
+   USE crs , ONLY :   e2u        =>   e2u_crs        !: horizontal scale factors at u-point (m)
+   USE crs , ONLY :   e1v        =>   e1v_crs        !: horizontal scale factors at v-point (m)
+   USE crs , ONLY :   e2v        =>   e2v_crs        !: horizontal scale factors at v-point (m)  
+   USE crs , ONLY :   e3t        =>  e3t_crs         !: vertical scale factors at t-
+   USE crs , ONLY :   e3t_0      =>  e3t_crs         !: vertical scale factors at t-
+   USE crs , ONLY :   fse3t      =>  e3t_crs
+   USE crs , ONLY :   fse3t_b      =>  e3t_crs
+   USE crs , ONLY :   fse3t_a      =>  e3t_crs
+   USE crs , ONLY :   fse3w      =>  e3w_crs
+   USE crs , ONLY :   e3u        =>  e3u_crs         !: vertical scale factors at u-
+   USE crs , ONLY :   e3u_0      =>  e3u_crs         !: vertical scale factors at u-
+   USE crs , ONLY :   e3v        =>  e3v_crs         !: vertical scale factors v-
+   USE crs , ONLY :   e3v_0      =>  e3v_crs         !: vertical scale factors v-
+   USE crs , ONLY :   e3w        =>  e3w_crs         !: w-points (m)
+   USE crs , ONLY :   e3w_0      =>  e3w_crs         !: w-points (m)
+   USE crs , ONLY :   e3f        =>  e3f_crs         !: f-points (m)
+   USE crs , ONLY :   ff         =>  ff_crs         !: f-points (m)
+
+   USE crs , ONLY :   gdept_0    =>  gdept_crs       !: depth of t-points (m)
+   USE dom_oce , ONLY :   gdept_1d   =>  gdept_1d      !: depth of t-points (m)
+#if defined key_zco
+   USE crs , ONLY :   gdept      =>  gdept_crs       !: depth of t-points (m)
+   USE crs , ONLY :   gdepw      =>  gdepw_crs       !: depth of t-points (m)
+#endif
+  !* masks, bathymetry *
+   USE crs , ONLY :   mbkt       =>   mbkt_crs       !: vertical index of the bottom last T- ocean level
+   USE crs , ONLY :   mbku       =>   mbku_crs       !: vertical index of the bottom last U- ocean level
+   USE crs , ONLY :   mbkv       =>   mbkv_crs       !: vertical index of the bottom last V- ocean level
+   USE crs , ONLY :   tmask_i    =>   tmask_i_crs    !: Interior mask at t-points
+   USE crs , ONLY :   tmask      =>   tmask_crs      !: land/ocean mask at t-points
+   USE crs , ONLY :   umask      =>   umask_crs      !: land/ocean mask at u-points   
+   USE crs , ONLY :   vmask      =>   vmask_crs      !: land/ocean mask at v-points 
+   USE crs , ONLY :   fmask      =>   fmask_crs      !: land/ocean mask at f-points 
+
+ !* ocean fields: here now and after fields *
+!cbr?   USE crs , ONLY :   ua      =>    ua_crs      !: i-horizontal velocity (m s-1) 
+!cbr?   USE crs , ONLY :   va      =>    va_crs      !: j-horizontal velocity (m s-1)
+   USE crs , ONLY :   un      =>    un_crs      !: i-horizontal velocity (m s-1) 
+   USE crs , ONLY :   vn      =>    vn_crs      !: j-horizontal velocity (m s-1)
+   USE crs , ONLY :   wn      =>    wn_crs      !: vertical velocity (m s-1)  
+   USE crs , ONLY :   tsn     =>    tsn_crs     !: 4D array contaning ( tn, sn )
+   USE oce , ONLY :   tsb     =>    tsb     !: 4D array contaning ( tb, sb )
+   USE oce , ONLY :   tsa     =>    tsa     !: 4D array contaning ( ta, sa )
+   USE oce , ONLY :   rhop    =>    rhop    !: potential volumic mass (kg m-3) 
+   USE oce , ONLY :   rhd     =>    rhd     !: in situ density anomalie rhd=(rho-rau0)/rau0 (no units)
+   USE crs , ONLY :   hdivn   =>    hdivn_crs   !: horizontal divergence (1/s)
+   USE crs , ONLY :   hdivb   =>    hdivb_crs   !: horizontal divergence (1/s)
+   USE crs , ONLY :   sshb    =>    sshb_crs    !: sea surface height at t-point [m]   
+   USE crs , ONLY :   sshn    =>    sshn_crs    !: sea surface height at t-point [m]   
+   USE crs , ONLY :   ssha    =>    ssha_crs    !: sea surface height at t-point [m]   
+
+   !* surface fluxes *
+   USE crs , ONLY :   utau       =>    utau_crs       !: i-surface stress component
+   USE crs , ONLY :   vtau       =>    vtau_crs       !: j-surface stress component
+   USE crs , ONLY :   wndm       =>    wndm_crs       !: 10m wind speed 
+   USE crs , ONLY :   qsr        =>    qsr_crs        !: penetrative solar radiation (w m-2)  
+   USE crs , ONLY :   emp        =>    emp_crs        !: freshwater budget: volume flux               [Kg/m2/s]
+   USE crs , ONLY :   emp_b      =>    emp_b_crs      !: freshwater budget: volume flux               [Kg/m2/s]
+   USE crs , ONLY :   sfx        =>    sfx_crs        !: freshwater budget: concentration/dillution   [Kg/m2/s]
+   USE crs , ONLY :   fmmflx     =>    fmmflx_crs     !: freshwater budget: volume flux               [Kg/m2/s]
+   USE crs , ONLY :   rnf        =>    rnf_crs        !: river runoff   [Kg/m2/s]
+   USE crs , ONLY :   fr_i       =>    fr_i_crs       !: ice fraction (between 0 to 1)
+
+   USE crs , ONLY :   avt        =>   avt_crs         !: vert. diffusivity coef. at w-point for temp  
+#if defined key_zdfddm
+   USE crs , ONLY :   avs        =>   avs_crs         !: salinity vertical diffusivity coeff. at w-point
+#endif
+
+!cbr   USE trc_oce
+   USE trc_oce, ONLY : lk_offline
+   USE trc_oce, ONLY : nn_dttrc
+
+   USE crs , ONLY :   nmln        =>   nmln_crs        !: number of level in the mixed layer
+   USE crs , ONLY :   hmld        =>   hmld_crs        !: mixing layer depth (turbocline)
+   USE crs , ONLY :   hmlp        =>   hmlp_crs        !: mixed layer depth  (rho=rho0+zdcrit) (m)
+   USE crs , ONLY :   hmlpt       =>   hmlpt_crs       !: mixed layer depth at t-points (m)
+
+  !* direction of lateral diffusion *
+#if   defined key_ldfslp
+   USE ldfslp_crs , ONLY :   uslp       =>   uslp_crs         !: i-direction slope at u-, w-points
+   USE ldfslp_crs , ONLY :   vslp       =>   vslp_crs         !: j-direction slope at v-, w-points
+   USE ldfslp_crs , ONLY :   wslpi      =>   wslpi_crs        !: i-direction slope at u-, w-points
+   USE ldfslp_crs , ONLY :   wslpj      =>   wslpj_crs        !: j-direction slope at v-, w-points
+#endif
+
+#else
+
    !!----------------------------------------------------------------------
    !!   'key_top'                                                TOP models
@@ -24,4 +201,78 @@
    USE par_oce , ONLY :   jp_sal   =>   jp_sal     !: indice for salinity
 
+  !* model domain *
+   USE dom_oce , ONLY : narea => narea
+   USE dom_oce , ONLY : nproc => nproc
+   USE dom_oce , ONLY : nimpp => nimpp
+   USE dom_oce , ONLY : njmpp => njmpp
+   USE dom_oce , ONLY : nreci => nreci
+   USE dom_oce , ONLY : nrecj => nrecj
+   USE dom_oce , ONLY : nlci  => nlci
+   USE dom_oce , ONLY : nldi  => nldi
+   USE dom_oce , ONLY : nlei  => nlei
+   USE dom_oce , ONLY : nlcj  => nlcj
+   USE dom_oce , ONLY : nldj  => nldj
+   USE dom_oce , ONLY : nlej  => nlej
+   USE dom_oce , ONLY : nlcit  => nlcit
+   USE dom_oce , ONLY : nldit  => nldit
+   USE dom_oce , ONLY : nleit  => nleit
+   USE dom_oce , ONLY : nlcjt  => nlcjt
+   USE dom_oce , ONLY : nldjt  => nldjt
+   USE dom_oce , ONLY : nlejt  => nlejt
+   USE dom_oce , ONLY : nimppt => nimppt
+   USE dom_oce , ONLY : njmppt => njmppt
+   USE dom_oce , ONLY : ibonit => ibonit
+   USE dom_oce , ONLY : ibonjt => ibonjt
+   USE dom_oce , ONLY : lk_vvl => lk_vvl
+   USE dom_oce , ONLY : rdt => rdt
+   USE dom_oce , ONLY : ln_zco => ln_zco
+   USE dom_oce , ONLY : ln_zps => ln_zps
+   USE dom_oce , ONLY : ln_sco => ln_sco
+   USE dom_oce , ONLY : neuler => neuler
+
+   USE dom_oce,  ONLY : mi0 => mi0
+   USE dom_oce,  ONLY : mi1 => mi1
+   USE dom_oce,  ONLY : mj0 => mj0
+   USE dom_oce,  ONLY : mj1 => mj1
+
+   USE dom_oce , ONLY :   glamt      =>   glamt      !: longitude of t-point (degre)  
+   USE dom_oce , ONLY :   glamu      =>   glamu      !: longitude of t-point (degre)  
+   USE dom_oce , ONLY :   glamv      =>   glamv      !: longitude of t-point (degre)  
+   USE dom_oce , ONLY :   glamf      =>   glamf      !: longitude of t-point (degre)  
+   USE dom_oce , ONLY :   gphit      =>   gphit      !: latitude  of t-point (degre)   
+   USE dom_oce , ONLY :   gphiu      =>   gphiu      !: latitude  of t-point (degre)   
+   USE dom_oce , ONLY :   gphiv      =>   gphiv      !: latitude  of t-point (degre)   
+   USE dom_oce , ONLY :   gphif      =>   gphif     !: latitude  of t-point (degre)   
+   USE dom_oce , ONLY :   e1t        =>   e1t        !: horizontal scale factors at t-point (m)  
+   USE dom_oce , ONLY :   e2t        =>   e2t        !: horizontal scale factors at t-point (m)   
+   USE dom_oce , ONLY :   e1e2t      =>   e1e2t      !: cell surface at t-point (m2)
+   USE dom_oce , ONLY :   e1u        =>   e1u        !: horizontal scale factors at u-point (m)
+   USE dom_oce , ONLY :   e2u        =>   e2u        !: horizontal scale factors at u-point (m)
+   USE dom_oce , ONLY :   e1v        =>   e1v        !: horizontal scale factors at v-point (m)
+   USE dom_oce , ONLY :   e2v        =>   e2v        !: horizontal scale factors at v-point (m)  
+   USE dom_oce , ONLY :   e3t        =>  e3t_0         !: vertical scale factors at t-
+   USE dom_oce , ONLY :   e3t_0      =>  e3t_0         !: vertical scale factors at t-
+   USE dom_oce , ONLY :   fse3t      =>  e3t_0
+   USE dom_oce , ONLY :   fse3t_b      =>  e3t_0
+   USE dom_oce , ONLY :   fse3t_a      =>  e3t_0
+   USE dom_oce , ONLY :   fse3w      =>  e3w_0
+   USE dom_oce , ONLY :   e3u        =>  e3u_0         !: vertical scale factors at u-
+   USE dom_oce , ONLY :   e3u_0      =>  e3u_0         !: vertical scale factors at u-
+   USE dom_oce , ONLY :   e3v        =>  e3v_0         !: vertical scale factors v-
+   USE dom_oce , ONLY :   e3v_0      =>  e3v_0         !: vertical scale factors v-
+   USE dom_oce , ONLY :   e3w        =>  e3w_0         !: w-points (m)
+   USE dom_oce , ONLY :   e3w_0      =>  e3w_0         !: w-points (m)
+   USE dom_oce , ONLY :   e3f        =>  e3f_0         !: f-points (m)
+   USE dom_oce , ONLY :   ff         =>  ff         !: f-points (m)
+   USE dom_oce , ONLY :   gdept_0    =>  gdept_0         !: f-points (m)
+   USE dom_oce , ONLY :   gdept_1d   => gdept_1d          !: f-points (m)
+   USE dom_oce , ONLY :   tmask      => tmask          !: f-points (m)
+   USE dom_oce , ONLY :   umask      => umask          !: f-points (m)
+   USE dom_oce , ONLY :   vmask      => vmask          !: f-points (m)
+   USE dom_oce , ONLY :   tmask_i      => tmask_i          !: f-points (m)
+   USE dom_oce , ONLY :   mbkt      => mbkt          !: f-points (m)
+   USE dom_oce , ONLY :   mbku      => mbku          !: f-points (m)
+   USE dom_oce , ONLY :   mbkv      => mbkv          !: f-points (m)
+
    !* IO manager *
    USE in_out_manager    
@@ -49,5 +300,6 @@
 
    !* model domain *
-   USE dom_oce 
+   !cbr USE dom_oce , ONLY : e3w_0
+   USE dom_oce , ONLY :  lzoom => lzoom 
 
    USE domvvl, ONLY : un_td, vn_td          !: thickness diffusion transport
@@ -66,7 +318,4 @@
    USE oce , ONLY :   rhop    =>    rhop    !: potential volumic mass (kg m-3) 
    USE oce , ONLY :   rhd     =>    rhd     !: in situ density anomalie rhd=(rho-rau0)/rau0 (no units)
-#if defined key_offline
-   USE oce , ONLY :   rab_n   =>    rab_n   !: local thermal/haline expension ratio at T-points
-#endif
    USE oce , ONLY :   hdivn   =>    hdivn   !: horizontal divergence (1/s)
    USE oce , ONLY :   rotn    =>    rotn    !: relative vorticity    [s-1]
@@ -135,4 +384,5 @@
 # endif
 
+#endif
 #else
    !!----------------------------------------------------------------------
Index: /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcdia.F90
===================================================================
--- /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcdia.F90	(revision 5104)
+++ /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcdia.F90	(revision 5105)
@@ -20,6 +20,5 @@
    !! trcdib_wr   : outputs of biological fields
    !!----------------------------------------------------------------------
-   USE dom_oce         ! ocean space and time domain variables 
-   USE oce_trc
+   USE trc_oce, ONLY : lk_offline ! offline flag
    USE trc
    USE par_trc
Index: /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcdta.F90
===================================================================
--- /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcdta.F90	(revision 5104)
+++ /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcdta.F90	(revision 5105)
@@ -19,5 +19,4 @@
    USE oce_trc       !  shared variables between ocean and passive tracers
    USE trc           !  passive tracers common variables
-   USE iom           !  I/O manager
    USE lib_mpp       !  MPP library
    USE fldread       !  read input fields
Index: /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcini.F90
===================================================================
--- /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 5104)
+++ /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 5105)
@@ -25,10 +25,12 @@
    USE trcini_my_trc   ! MY_TRC   initialisation
    USE trcdta          ! initialisation from files
-   USE daymod          ! calendar manager
-   USE zpshde          ! partial step: hor. derivative   (zps_hde routine)
+   USE zpshde,ONLY: zps_hde    ! partial step: hor. derivative   (zps_hde routine)
+   USE zpshde_crs      ! partial step: hor. derivative   (zps_hde routine)
    USE prtctl_trc      ! Print control passive tracers (prt_ctl_trc_init routine)
    USE trcsub          ! variables to substep passive tracers
    USE lib_mpp         ! distribued memory computing library
-   USE sbc_oce
+   USE sbc_oce, ONLY : ltrcdm2dc
+   USE crs    , ONLY : ln_crs
+   USE dom_oce, ONLY : nn_cla
  
    IMPLICIT NONE
@@ -143,7 +145,11 @@
  
       tra(:,:,:,:) = 0._wp
-      IF( ln_zps .AND. .NOT. lk_c1d )   &              ! Partial steps: before horizontal gradient of passive
-        &    CALL zps_hde( nit000, jptra, trn, pgtu=gtru, pgtv=gtrv, sgtu=gtrui, sgtv=gtrvi )       ! tracers at the bottom ocean level
-
+      IF( ln_zps .AND. .NOT. lk_c1d )THEN              ! Partial steps: before horizontal gradient of passive
+         IF( ln_crs )  THEN
+            CALL zps_hde_crs( nit000, jptra, trn, gtru, gtrv )
+         ELSE
+            CALL zps_hde( nit000, jptra, trn, pgtu=gtru, pgtv=gtrv, sgtu=gtrui, sgtv=gtrvi )! tracers at the bottom ocean level
+         ENDIF
+      ENDIF
       !
       IF( nn_dttrc /= 1 )        CALL trc_sub_ini      ! Initialize variables for substepping passive tracers
@@ -188,7 +194,9 @@
       !!----------------------------------------------------------------------
       USE trcadv        , ONLY:   trc_adv_alloc          ! TOP-related alloc routines...
+      USE trcadv_crs    , ONLY:   trc_adv_alloc_crs      ! TOP-related alloc routines..
       USE trc           , ONLY:   trc_alloc
       USE trcnxt        , ONLY:   trc_nxt_alloc
       USE trczdf        , ONLY:   trc_zdf_alloc
+      USE trczdf_crs    , ONLY:   trc_zdf_alloc_crs
       USE trdtrc_oce    , ONLY:   trd_trc_oce_alloc
 #if defined key_trdmxl_trc 
@@ -200,7 +208,9 @@
       !
       ierr =        trc_adv_alloc()          ! Start of TOP-related alloc routines...
+      ierr = ierr + trc_adv_alloc_crs()
       ierr = ierr + trc_alloc    ()
       ierr = ierr + trc_nxt_alloc()
       ierr = ierr + trc_zdf_alloc()
+      ierr = ierr + trc_zdf_alloc_crs()
       ierr = ierr + trd_trc_oce_alloc()
 #if defined key_trdmxl_trc 
Index: /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcrst.F90
===================================================================
--- /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 5104)
+++ /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 5105)
@@ -23,9 +23,12 @@
    !!   trc_rst_wri    : write restart file
    !!----------------------------------------------------------------------
-   USE oce_trc
+   USE oce_trc ! ,ONLY: jprstlib
    USE trc
    USE trcnam_trp
-   USE iom
-   USE daymod
+   USE iom_def , ONLY : jprstlib , jprstdimg , jpnf90 , jpdom_autoglo 
+   USE iom , ONLY : iom_open , iom_get , iom_varid , iom_rstput , iom_close
+   USE dom_oce, ONLY: ndastp ,adatrj  , rdttra
+   USE daymod , ONLY : day_init
+
    IMPLICIT NONE
    PRIVATE
@@ -137,5 +140,5 @@
           CALL trc_rst_stat            ! statistics
           CALL iom_close( numrtw )     ! close the restart file (only at last time step)
-#if ! defined key_trdmxl_trc
+#if ! defined key_trdmld_trc
           lrst_trc = .FALSE.
 #endif
Index: /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcstp.F90
===================================================================
--- /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcstp.F90	(revision 5104)
+++ /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcstp.F90	(revision 5105)
@@ -11,5 +11,5 @@
    !!----------------------------------------------------------------------
    USE oce_trc          ! ocean dynamics and active tracers variables
-   USE sbc_oce
+   USE sbc_oce , ONLY : ltrcdm2dc,qsr_mean
    USE trc
    USE trctrp           ! passive tracers transport
@@ -17,11 +17,12 @@
    USE prtctl_trc       ! Print control for debbuging
    USE trcdia
-   USE trcwri
+   USE trcwri , ONLY : trc_wri
    USE trcrst
    USE trdtrc_oce
    USE trdmxl_trc
-   USE iom
+   USE iom, ONLY : lk_iomput , iom_close
    USE in_out_manager
    USE trcsub
+   USE dom_oce, ONLY : nday, nmonth, nyear
 
    IMPLICIT NONE
